/**
 * @Author: wzy
 * @Date: 2021-11-16
 * @LastEditTime: 
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @filePath:
 */

#pragma once

#include <iostream>
#include <vector>
#include <cmath>

#include "PD_Input.h"
// #include "mpc_drv_msgs/msg/road_info.hpp"
// #include "mpc_drv_msgs/msg/road_edge.hpp"
#include "PD_DynamicObjRisk.h"
#include "../../source/PD_commonfunc.h"
#include "../../../../include/CtApBehaviorAnalysis_/interface/rm_road_info.h"

#define FLAG_STN_IOOUT 0
#if FLAG_STN_IOOUT != 0
#include <fstream>
#endif

namespace ADC
{
namespace PD_StnObstcRsk
{

// struct lat_dis_and_edgetype
// {
//     float lat_dis = 0.0f;
//     uint8_t edge_type;
// };

class StnObstcRisk
{
public:
    StnObstcRisk(const PD::PD_Input &pd_input,
                 const uint8_t pd_LatTrj_EV_ActionType,
                 const std::vector<ADC::PD_EgoVehTrj::EgoVeh_TrjPnt>& EgoVeh_trace_list);
    ~StnObstcRisk() = default;

private:
    bool init(const PD::PD_Input &pd_input,
              const uint8_t pd_LatTrj_EV_ActionType,
              const std::vector<ADC::PD_EgoVehTrj::EgoVeh_TrjPnt>& EgoVeh_trace_list);
    bool initFlag = true;

/**
  * @brief   Calculate the minidistance of lane boundary
  * @param   
  * @return  the minidistance of lane boundary
  */
    float CalculateBdrLatMinDis();
/**
  * @brief   Calculate the integral of cross safe zoon about lane boundary
  * @param   
  * @return  the integral of cross safe zoon about lane boundary
  */
    float CalculateBdrLatCrsSfZnItg();

private:
    uint8_t _ego_action_type;  
    // std::vector<RoadEdge> _left_road_edge_list;
    // std::vector<RoadEdge> _right_road_edge_list;
    std::vector<RoadEdgeSegment> _left_road_edge_segment_list;
    std::vector<RoadEdgeSegment> _right_road_edge_segment_list;
    std::vector<RoadEdge> _road_edge_list;
    std::vector<ADC::PD_DynmcObjRsk::EgoVeh_Point> _egoVeh_TrjPnt;
    float _pos_ego_start = 0.0f;
    // The distance about road edge
    std::vector<float> _lat_dis_list;
    // std::vector<lat_dis_and_edgetype> _lat_dis_edgetype_list;
    float timesampl = 0.1f;

public:
    void process();
    float m_BdrLatMinDis = 0.0f;          //自车与道路边界的最小横向距离
    float m_BdrLatCrsSfZnItg = 0.0f;      //自车超道路边界安全区域的积分
};


}   //namespace PD_StnObstcRsk
}   //namespace ADC